/* Application.c generated by valac 0.48.19, the Vala compiler
 * generated from Application.vala, do not modify */

/*
 * Copyright (c) 2011-2018 elementary LLC. (https://github.com/elementary/camera)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Marcus Wichelmann <marcus.wichelmann@hotmail.de>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <handy.h>
#include <gio/gio.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <string.h>
#include <stdlib.h>
#include <gst/gst.h>
#include <locale.h>
#include <glib/gi18n-lib.h>

#define CAMERA_TYPE_APPLICATION (camera_application_get_type ())
#define CAMERA_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CAMERA_TYPE_APPLICATION, CameraApplication))
#define CAMERA_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CAMERA_TYPE_APPLICATION, CameraApplicationClass))
#define CAMERA_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CAMERA_TYPE_APPLICATION))
#define CAMERA_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CAMERA_TYPE_APPLICATION))
#define CAMERA_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CAMERA_TYPE_APPLICATION, CameraApplicationClass))

typedef struct _CameraApplication CameraApplication;
typedef struct _CameraApplicationClass CameraApplicationClass;
typedef struct _CameraApplicationPrivate CameraApplicationPrivate;

#define CAMERA_TYPE_MAIN_WINDOW (camera_main_window_get_type ())
#define CAMERA_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CAMERA_TYPE_MAIN_WINDOW, CameraMainWindow))
#define CAMERA_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CAMERA_TYPE_MAIN_WINDOW, CameraMainWindowClass))
#define CAMERA_IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CAMERA_TYPE_MAIN_WINDOW))
#define CAMERA_IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CAMERA_TYPE_MAIN_WINDOW))
#define CAMERA_MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CAMERA_TYPE_MAIN_WINDOW, CameraMainWindowClass))

typedef struct _CameraMainWindow CameraMainWindow;
typedef struct _CameraMainWindowClass CameraMainWindowClass;
enum  {
	CAMERA_APPLICATION_0_PROPERTY,
	CAMERA_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* camera_application_properties[CAMERA_APPLICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _CameraApplication {
	GtkApplication parent_instance;
	CameraApplicationPrivate * priv;
	CameraMainWindow* main_window;
};

struct _CameraApplicationClass {
	GtkApplicationClass parent_class;
};

static gpointer camera_application_parent_class = NULL;
extern GSettings* camera_application_settings;
GSettings* camera_application_settings = NULL;

GType camera_application_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CameraApplication, g_object_unref)
GType camera_main_window_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CameraMainWindow, g_object_unref)
static void camera_application_real_activate (GApplication* base);
CameraMainWindow* camera_main_window_new (CameraApplication* application);
CameraMainWindow* camera_main_window_construct (GType object_type,
                                                CameraApplication* application);
static gint camera_application_main (gchar** args,
                              gint args_length1);
CameraApplication* camera_application_new (void);
CameraApplication* camera_application_construct (GType object_type);
static GObject * camera_application_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
#define GETTEXT_PACKAGE "io.elementary.camera"
#define LOCALEDIR "/usr/share/locale"
static void _camera_application___lambda23_ (CameraApplication* self);
static void __camera_application___lambda23__g_simple_action_activate (GSimpleAction* _sender,
                                                                GVariant* parameter,
                                                                gpointer self);
static void camera_application_finalize (GObject * obj);
static GType camera_application_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static void
camera_application_real_activate (GApplication* base)
{
	CameraApplication * self;
	GList* _tmp0_;
	self = (CameraApplication*) base;
	_tmp0_ = gtk_application_get_windows ((GtkApplication*) self);
	if (_tmp0_ == NULL) {
		CameraMainWindow* _tmp1_;
		gint width = 0;
		gint height = 0;
		GSettings* _tmp2_;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		GdkGeometry hints = {0};
		CameraMainWindow* _tmp5_;
		GdkGeometry _tmp6_;
		CameraMainWindow* _tmp7_;
		GSettings* _tmp8_;
		CameraMainWindow* _tmp10_;
		CameraMainWindow* _tmp11_;
		_tmp1_ = camera_main_window_new (self);
		g_object_ref_sink (_tmp1_);
		_g_object_unref0 (self->main_window);
		self->main_window = _tmp1_;
		_tmp2_ = camera_application_settings;
		g_settings_get (_tmp2_, "window-size", "(ii)", &_tmp3_, &_tmp4_);
		width = _tmp3_;
		height = _tmp4_;
		memset (&hints, 0, sizeof (GdkGeometry));
		hints.min_aspect = 1.0;
		hints.max_aspect = -1.0;
		hints.min_width = 436;
		hints.min_height = 352;
		_tmp5_ = self->main_window;
		_tmp6_ = hints;
		gtk_window_set_geometry_hints ((GtkWindow*) _tmp5_, NULL, &_tmp6_, GDK_HINT_ASPECT | GDK_HINT_MIN_SIZE);
		_tmp7_ = self->main_window;
		gtk_window_resize ((GtkWindow*) _tmp7_, width, height);
		_tmp8_ = camera_application_settings;
		if (g_settings_get_boolean (_tmp8_, "window-maximized")) {
			CameraMainWindow* _tmp9_;
			_tmp9_ = self->main_window;
			gtk_window_maximize ((GtkWindow*) _tmp9_);
		}
		_tmp10_ = self->main_window;
		g_object_set ((GtkWindow*) _tmp10_, "window-position", GTK_WIN_POS_CENTER, NULL);
		_tmp11_ = self->main_window;
		gtk_widget_show_all ((GtkWidget*) _tmp11_);
	} else {
		CameraMainWindow* _tmp12_;
		_tmp12_ = self->main_window;
		gtk_window_present ((GtkWindow*) _tmp12_);
	}
}

static gint
camera_application_main (gchar** args,
                         gint args_length1)
{
	CameraApplication* application = NULL;
	CameraApplication* _tmp0_;
	gint result = 0;
	gst_init ((gint*) (&args_length1), &args);
	_tmp0_ = camera_application_new ();
	application = _tmp0_;
	result = g_application_run ((GApplication*) application, (gint) args_length1, args);
	_g_object_unref0 (application);
	return result;
}

int
main (int argc,
      char ** argv)
{
	return camera_application_main (argv, argc);
}

CameraApplication*
camera_application_construct (GType object_type)
{
	CameraApplication * self = NULL;
	self = (CameraApplication*) g_object_new (object_type, NULL);
	return self;
}

CameraApplication*
camera_application_new (void)
{
	return camera_application_construct (CAMERA_TYPE_APPLICATION);
}

static void
_camera_application___lambda23_ (CameraApplication* self)
{
	CameraMainWindow* _tmp0_;
	_tmp0_ = self->main_window;
	if (_tmp0_ != NULL) {
		CameraMainWindow* _tmp1_;
		_tmp1_ = self->main_window;
		gtk_widget_destroy ((GtkWidget*) _tmp1_);
	}
}

static void
__camera_application___lambda23__g_simple_action_activate (GSimpleAction* _sender,
                                                           GVariant* parameter,
                                                           gpointer self)
{
	_camera_application___lambda23_ ((CameraApplication*) self);
}

static GObject *
camera_application_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CameraApplication * self;
	GSimpleAction* quit_action = NULL;
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	GSimpleAction* _tmp5_;
	parent_class = G_OBJECT_CLASS (camera_application_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAMERA_TYPE_APPLICATION, CameraApplication);
	setlocale (LC_ALL, "");
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);
	g_application_set_application_id ((GApplication*) self, "io.elementary.camera");
	_tmp0_ = g_simple_action_new ("quit", NULL);
	quit_action = _tmp0_;
	_tmp1_ = quit_action;
	g_action_map_add_action ((GActionMap*) self, (GAction*) _tmp1_);
	_tmp2_ = g_strdup ("<Control>q");
	_tmp3_ = g_new0 (gchar*, 1 + 1);
	_tmp3_[0] = _tmp2_;
	_tmp4_ = _tmp3_;
	_tmp4__length1 = 1;
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app.quit", _tmp4_);
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
	_tmp5_ = quit_action;
	g_signal_connect_object (_tmp5_, "activate", (GCallback) __camera_application___lambda23__g_simple_action_activate, self, 0);
	_g_object_unref0 (quit_action);
	return obj;
}

static void
camera_application_class_init (CameraApplicationClass * klass,
                               gpointer klass_data)
{
	GSettings* _tmp0_;
	camera_application_parent_class = g_type_class_peek_parent (klass);
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) camera_application_real_activate;
	G_OBJECT_CLASS (klass)->constructor = camera_application_constructor;
	G_OBJECT_CLASS (klass)->finalize = camera_application_finalize;
	_tmp0_ = g_settings_new ("io.elementary.camera.settings");
	_g_object_unref0 (camera_application_settings);
	camera_application_settings = _tmp0_;
}

static void
camera_application_instance_init (CameraApplication * self,
                                  gpointer klass)
{
	self->main_window = NULL;
}

static void
camera_application_finalize (GObject * obj)
{
	CameraApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAMERA_TYPE_APPLICATION, CameraApplication);
	_g_object_unref0 (self->main_window);
	G_OBJECT_CLASS (camera_application_parent_class)->finalize (obj);
}

static GType
camera_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CameraApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) camera_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CameraApplication), 0, (GInstanceInitFunc) camera_application_instance_init, NULL };
	GType camera_application_type_id;
	camera_application_type_id = g_type_register_static (gtk_application_get_type (), "CameraApplication", &g_define_type_info, 0);
	return camera_application_type_id;
}

GType
camera_application_get_type (void)
{
	static volatile gsize camera_application_type_id__volatile = 0;
	if (g_once_init_enter (&camera_application_type_id__volatile)) {
		GType camera_application_type_id;
		camera_application_type_id = camera_application_get_type_once ();
		g_once_init_leave (&camera_application_type_id__volatile, camera_application_type_id);
	}
	return camera_application_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

