/* TimerButton.c generated by valac 0.48.19, the Vala compiler
 * generated from TimerButton.vala, do not modify */

/*
 * Copyright (c) 2011-2018 elementary LLC. (https://github.com/elementary/camera)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Alain M. <alain23@protonmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

#define CAMERA_WIDGETS_TYPE_TIMER_BUTTON (camera_widgets_timer_button_get_type ())
#define CAMERA_WIDGETS_TIMER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CAMERA_WIDGETS_TYPE_TIMER_BUTTON, CameraWidgetsTimerButton))
#define CAMERA_WIDGETS_TIMER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CAMERA_WIDGETS_TYPE_TIMER_BUTTON, CameraWidgetsTimerButtonClass))
#define CAMERA_WIDGETS_IS_TIMER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CAMERA_WIDGETS_TYPE_TIMER_BUTTON))
#define CAMERA_WIDGETS_IS_TIMER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CAMERA_WIDGETS_TYPE_TIMER_BUTTON))
#define CAMERA_WIDGETS_TIMER_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CAMERA_WIDGETS_TYPE_TIMER_BUTTON, CameraWidgetsTimerButtonClass))

typedef struct _CameraWidgetsTimerButton CameraWidgetsTimerButton;
typedef struct _CameraWidgetsTimerButtonClass CameraWidgetsTimerButtonClass;
typedef struct _CameraWidgetsTimerButtonPrivate CameraWidgetsTimerButtonPrivate;
typedef enum  {
	CAMERA_WIDGETS_TIMER_BUTTON_DELAY_DISABLED = 0,
	CAMERA_WIDGETS_TIMER_BUTTON_DELAY_3_SEC = 3,
	CAMERA_WIDGETS_TIMER_BUTTON_DELAY_5_SEC = 5,
	CAMERA_WIDGETS_TIMER_BUTTON_DELAY_10_SEC = 10
} CameraWidgetsTimerButtonDelay;

#define CAMERA_WIDGETS_TIMER_BUTTON_TYPE_DELAY (camera_widgets_timer_button_delay_get_type ())
enum  {
	CAMERA_WIDGETS_TIMER_BUTTON_0_PROPERTY,
	CAMERA_WIDGETS_TIMER_BUTTON_NUM_PROPERTIES
};
static GParamSpec* camera_widgets_timer_button_properties[CAMERA_WIDGETS_TIMER_BUTTON_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _CameraWidgetsTimerButton {
	GtkButton parent_instance;
	CameraWidgetsTimerButtonPrivate * priv;
	CameraWidgetsTimerButtonDelay delay;
};

struct _CameraWidgetsTimerButtonClass {
	GtkButtonClass parent_class;
};

static gpointer camera_widgets_timer_button_parent_class = NULL;
extern GSettings* camera_application_settings;

GType camera_widgets_timer_button_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CameraWidgetsTimerButton, g_object_unref)
GType camera_widgets_timer_button_delay_get_type (void) G_GNUC_CONST;
CameraWidgetsTimerButtonDelay camera_widgets_timer_button_delay_next (CameraWidgetsTimerButtonDelay self);
gchar* camera_widgets_timer_button_delay_to_string (CameraWidgetsTimerButtonDelay self);
CameraWidgetsTimerButton* camera_widgets_timer_button_new (void);
CameraWidgetsTimerButton* camera_widgets_timer_button_construct (GType object_type);
static GObject * camera_widgets_timer_button_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void _camera_widgets_timer_button___lambda9_ (CameraWidgetsTimerButton* self);
static void __camera_widgets_timer_button___lambda9__gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self);
static void camera_widgets_timer_button_finalize (GObject * obj);
static GType camera_widgets_timer_button_get_type_once (void);

CameraWidgetsTimerButtonDelay
camera_widgets_timer_button_delay_next (CameraWidgetsTimerButtonDelay self)
{
	CameraWidgetsTimerButtonDelay result = 0;
	switch (self) {
		case CAMERA_WIDGETS_TIMER_BUTTON_DELAY_3_SEC:
		{
			result = CAMERA_WIDGETS_TIMER_BUTTON_DELAY_5_SEC;
			return result;
		}
		case CAMERA_WIDGETS_TIMER_BUTTON_DELAY_5_SEC:
		{
			result = CAMERA_WIDGETS_TIMER_BUTTON_DELAY_10_SEC;
			return result;
		}
		case CAMERA_WIDGETS_TIMER_BUTTON_DELAY_10_SEC:
		{
			result = CAMERA_WIDGETS_TIMER_BUTTON_DELAY_DISABLED;
			return result;
		}
		default:
		{
			result = CAMERA_WIDGETS_TIMER_BUTTON_DELAY_3_SEC;
			return result;
		}
	}
}

gchar*
camera_widgets_timer_button_delay_to_string (CameraWidgetsTimerButtonDelay self)
{
	gchar* result = NULL;
	if (self == CAMERA_WIDGETS_TIMER_BUTTON_DELAY_DISABLED) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (_ ("Disabled"));
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup_printf (ngettext ("%d Sec", "%d Sec", (gulong) self), (gint) self);
		result = _tmp1_;
		return result;
	}
}

static GType
camera_widgets_timer_button_delay_get_type_once (void)
{
	static const GEnumValue values[] = {{CAMERA_WIDGETS_TIMER_BUTTON_DELAY_DISABLED, "CAMERA_WIDGETS_TIMER_BUTTON_DELAY_DISABLED", "disabled"}, {CAMERA_WIDGETS_TIMER_BUTTON_DELAY_3_SEC, "CAMERA_WIDGETS_TIMER_BUTTON_DELAY_3_SEC", "3-sec"}, {CAMERA_WIDGETS_TIMER_BUTTON_DELAY_5_SEC, "CAMERA_WIDGETS_TIMER_BUTTON_DELAY_5_SEC", "5-sec"}, {CAMERA_WIDGETS_TIMER_BUTTON_DELAY_10_SEC, "CAMERA_WIDGETS_TIMER_BUTTON_DELAY_10_SEC", "10-sec"}, {0, NULL, NULL}};
	GType camera_widgets_timer_button_delay_type_id;
	camera_widgets_timer_button_delay_type_id = g_enum_register_static ("CameraWidgetsTimerButtonDelay", values);
	return camera_widgets_timer_button_delay_type_id;
}

GType
camera_widgets_timer_button_delay_get_type (void)
{
	static volatile gsize camera_widgets_timer_button_delay_type_id__volatile = 0;
	if (g_once_init_enter (&camera_widgets_timer_button_delay_type_id__volatile)) {
		GType camera_widgets_timer_button_delay_type_id;
		camera_widgets_timer_button_delay_type_id = camera_widgets_timer_button_delay_get_type_once ();
		g_once_init_leave (&camera_widgets_timer_button_delay_type_id__volatile, camera_widgets_timer_button_delay_type_id);
	}
	return camera_widgets_timer_button_delay_type_id__volatile;
}

CameraWidgetsTimerButton*
camera_widgets_timer_button_construct (GType object_type)
{
	CameraWidgetsTimerButton * self = NULL;
	self = (CameraWidgetsTimerButton*) g_object_new (object_type, NULL);
	return self;
}

CameraWidgetsTimerButton*
camera_widgets_timer_button_new (void)
{
	return camera_widgets_timer_button_construct (CAMERA_WIDGETS_TYPE_TIMER_BUTTON);
}

static void
_camera_widgets_timer_button___lambda9_ (CameraWidgetsTimerButton* self)
{
	CameraWidgetsTimerButtonDelay _tmp0_;
	GSettings* _tmp1_;
	CameraWidgetsTimerButtonDelay _tmp2_;
	CameraWidgetsTimerButtonDelay _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	_tmp0_ = self->delay;
	self->delay = camera_widgets_timer_button_delay_next (_tmp0_);
	_tmp1_ = camera_application_settings;
	_tmp2_ = self->delay;
	g_settings_set_enum (_tmp1_, "delay", (gint) _tmp2_);
	_tmp3_ = self->delay;
	_tmp4_ = camera_widgets_timer_button_delay_to_string (_tmp3_);
	_tmp5_ = _tmp4_;
	gtk_button_set_label ((GtkButton*) self, _tmp5_);
	_g_free0 (_tmp5_);
}

static void
__camera_widgets_timer_button___lambda9__gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self)
{
	_camera_widgets_timer_button___lambda9_ ((CameraWidgetsTimerButton*) self);
}

static GObject *
camera_widgets_timer_button_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CameraWidgetsTimerButton * self;
	GSettings* _tmp0_;
	CameraWidgetsTimerButtonDelay _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkStyleContext* _tmp4_;
	parent_class = G_OBJECT_CLASS (camera_widgets_timer_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAMERA_WIDGETS_TYPE_TIMER_BUTTON, CameraWidgetsTimerButton);
	_tmp0_ = camera_application_settings;
	self->delay = (CameraWidgetsTimerButtonDelay) g_settings_get_enum (_tmp0_, "delay");
	_tmp1_ = self->delay;
	_tmp2_ = camera_widgets_timer_button_delay_to_string (_tmp1_);
	_tmp3_ = _tmp2_;
	gtk_button_set_label ((GtkButton*) self, _tmp3_);
	_g_free0 (_tmp3_);
	g_signal_connect_object ((GtkButton*) self, "clicked", (GCallback) __camera_widgets_timer_button___lambda9__gtk_button_clicked, self, 0);
	gtk_button_set_always_show_image ((GtkButton*) self, TRUE);
	gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("Delay before photo is taken"));
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp4_, GTK_STYLE_CLASS_FLAT);
	return obj;
}

static void
camera_widgets_timer_button_class_init (CameraWidgetsTimerButtonClass * klass,
                                        gpointer klass_data)
{
	camera_widgets_timer_button_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = camera_widgets_timer_button_constructor;
	G_OBJECT_CLASS (klass)->finalize = camera_widgets_timer_button_finalize;
}

static void
camera_widgets_timer_button_instance_init (CameraWidgetsTimerButton * self,
                                           gpointer klass)
{
}

static void
camera_widgets_timer_button_finalize (GObject * obj)
{
	CameraWidgetsTimerButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAMERA_WIDGETS_TYPE_TIMER_BUTTON, CameraWidgetsTimerButton);
	G_OBJECT_CLASS (camera_widgets_timer_button_parent_class)->finalize (obj);
}

static GType
camera_widgets_timer_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CameraWidgetsTimerButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) camera_widgets_timer_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CameraWidgetsTimerButton), 0, (GInstanceInitFunc) camera_widgets_timer_button_instance_init, NULL };
	GType camera_widgets_timer_button_type_id;
	camera_widgets_timer_button_type_id = g_type_register_static (gtk_button_get_type (), "CameraWidgetsTimerButton", &g_define_type_info, 0);
	return camera_widgets_timer_button_type_id;
}

GType
camera_widgets_timer_button_get_type (void)
{
	static volatile gsize camera_widgets_timer_button_type_id__volatile = 0;
	if (g_once_init_enter (&camera_widgets_timer_button_type_id__volatile)) {
		GType camera_widgets_timer_button_type_id;
		camera_widgets_timer_button_type_id = camera_widgets_timer_button_get_type_once ();
		g_once_init_leave (&camera_widgets_timer_button_type_id__volatile, camera_widgets_timer_button_type_id);
	}
	return camera_widgets_timer_button_type_id__volatile;
}

